Multi-Color Events in EJ2 JavaScript Scheduler control

18 Mar 20259 minutes to read

In Scheduler we can display the multiple colors within a single event. This can be achieved by using the template option available within the eventSettings property. Here, we’ve used SubCount as an additional field. The SubCount field contains the background color and height values. Based on these values, events will be divided into different colors.

function eventTemplate(data) {
    return `
      <div class='template-wrap'>
        ${data.SubCount.map((item) => `
          <div style='background:${item.background}; height:${item.height}'>
            <div class="subject">${data.Subject}</div>
          </div>
        `).join('')}
      </div>`;
}

var data = [{
    Id: 1,
    Subject: 'Environment Day',
    Description: 'A day that creates awareness to promote the healthy planet and reduce the air pollution crisis on nature earth.',
    StartTime: new Date(2024, 1, 15, 9, 0),
    EndTime: new Date(2024, 1, 15, 14, 0),
    SubCount: [
        { background: 'darkblue', height: '50%' },
        { background: 'lightblue', height: '50%' },
    ],
},
{
    Id: 2,
    Subject: 'Health Day',
    Description: 'A day that raises awareness on different health issues. It marks the anniversary of the foundation of WHO.',
    StartTime: new Date(2024, 1, 16, 9, 0),
    EndTime: new Date(2024, 1, 16, 14, 0),
    SubCount: [
        { background: 'yellow', height: '33.3%' },
        { background: 'yellowgreen', height: '33.3%' },
        { background: 'green', height: '33.3%' },
    ],
},
{
    Id: 3,
    Subject: 'Cancer Day',
    Description: 'A day that raises awareness on cancer and its preventive measures. Early detection saves life.',
    StartTime: new Date(2024, 1, 17, 9, 0),
    EndTime: new Date(2024, 1, 17, 14, 0),
    SubCount: [
        { background: 'pink', height: '50%' },
        { background: 'red', height: '50%' },
    ],
}];

var scheduleObj = new ej.schedule.Schedule({
    width: '100%',
    height: '650px',
    selectedDate: new Date(2024, 1, 15),
    views: [{ option: "Week" }],
    eventSettings: {
        dataSource: data,
        template: eventTemplate
    }
});
scheduleObj.appendTo('#Schedule');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Schedule Typescript Control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Schedule Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-base/styles/bootstrap5.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-buttons/styles/bootstrap5.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-calendars/styles/bootstrap5.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-dropdowns/styles/bootstrap5.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-inputs/styles/bootstrap5.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-navigations/styles/bootstrap5.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-popups/styles/bootstrap5.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-schedule/styles/bootstrap5.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/31.2.12/dist/ej2.min.js" type="text/javascript"></script>

    <style>
        .e-schedule .e-vertical-view .e-content-wrap .e-appointment,
        .e-schedule .e-timeline-view .e-content-wrap .e-appointment {
            border-radius: 8px;
        }

        .e-schedule .e-vertical-view .e-content-wrap .e-appointment .e-appointment-details {
            padding: 0;
            height: 100%;
        }

        .e-schedule .template-wrap {
            height: 100%;
            white-space: normal;
        }

        .e-schedule .template-wrap .subject {
            font-weight: 600;
            font-size: 15px;
            padding: 4px 4px 4px;
            height: 25px;
            text-overflow: ellipsis;
            white-space: nowrap;
            overflow: hidden;
        }

        .e-schedule .e-timeline-view .e-appointment .e-appointment-details {
            padding: 0;
            height: 100%;
            width: 100%;
        }

        .e-schedule .e-timeline-view .template-wrap {
            width: 100%;
        }

        .e-schedule .e-timeline-view .template-wrap .subject {
            font-size: 16px;
            height: 36px;
            text-align: center;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div id="Schedule"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Display multiple colors in single event in Vue Schedule component

2 Aug 202412 minutes to read

In Scheduler we can display the multiple colors within a single event. This can be achieved by using the eventTemplate option available within the views model. Here, we’ve used SubCount as an additional field. The SubCount field contains the background color and height values. Based on these values, events will be divided into different colors.

<template>
  <div class="schedule-vue-sample">
    <div class="col-md-12 control-section">
      <div class="content-wrapper">
        <ejs-schedule id="Schedule" width="100%" height="650px" :selectedDate="selectedDate" :eventSettings="eventSettings" :cssClass="cssClass">
          <e-views>
            <e-view option="Week" :eventTemplate="'eventTemplate'">
              <template v-slot:eventTemplate="{ data }">
                <div class="template-wrapper">
                  <div v-for="(item, index) in data.SubCount" :key="index" :style="{ background: item.background, height: item.height }">
                    <div class="subject"></div>
                  </div>
                </div>
              </template>
            </e-view>
          </e-views>
        </ejs-schedule>
      </div>
    </div>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { ScheduleComponent as EjsSchedule, ViewDirective as EView, ViewsDirective as EViews, Week, Resize, DragAndDrop } from '@syncfusion/ej2-vue-schedule';

const height = '550px';
const cssClass ='schedule-event-template';
const eventSettings = {
  dataSource: [
    {
      Id: 1,
      Subject: 'Environment Day',
      Description: 'A day that creates awareness to promote the healthy planet and reduce the air pollution crisis on nature earth.',
      StartTime: new Date(2024, 1, 15, 9, 0),
      EndTime: new Date(2024, 1, 15, 14, 0),
      SubCount: [
        { background: 'darkblue', height: '50%' },
        { background: 'lightblue', height: '50%' }
      ]
    },
    {
      Id: 2,
      Subject: 'Health Day',
      Description: 'A day that raises awareness on different health issues. It marks the anniversary of the foundation of WHO.',
      StartTime: new Date(2024, 1, 16, 9, 0),
      EndTime: new Date(2024, 1, 16, 14, 0),
      SubCount: [
        { background: 'yellow', height: '33.3%' },
        { background: 'yellowgreen', height: '33.3%' },
        { background: 'green', height: '33.3%' }
      ]
    },
    {
      Id: 3,
      Subject: 'Cancer Day',
      Description: 'A day that raises awareness on cancer and its preventive measures. Early detection saves life.',
      StartTime: new Date(2024, 1, 17, 9, 0),
      EndTime: new Date(2024, 1, 17, 14, 0),
      SubCount: [
        { background: 'pink', height: '50%' },
        { background: 'red', height: '50%' },
      ]
    }
  ] 
};
const selectedDate = new Date(2024, 1, 15);

provide('schedule', [Week, Resize, DragAndDrop]);

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-buttons/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-calendars/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-dropdowns/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-inputs/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-navigations/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-popups/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-schedule/styles/bootstrap5.css';
</style>
<template>
  <div class="schedule-vue-sample">
    <div class="col-md-12 control-section">
      <div class="content-wrapper">
        <ejs-schedule id="Schedule" width="100%" height="650px" :selectedDate="selectedDate" :eventSettings="eventSettings" :cssClass="cssClass">
          <e-views>
            <e-view option="Week" :eventTemplate="'eventTemplate'">
              <template v-slot:eventTemplate="{ data }">
                <div class="template-wrapper">
                  <div v-for="(item, index) in data.SubCount" :key="index" :style="{ background: item.background, height: item.height }">
                    <div class="subject"></div>
                  </div>
                </div>
              </template>
            </e-view>
          </e-views>
        </ejs-schedule>
      </div>
    </div>
  </div>
</template>
<script>
import { ScheduleComponent, ViewDirective, ViewsDirective, Week, Resize, DragAndDrop } from '@syncfusion/ej2-vue-schedule';

export default {
   components: {
    'ejs-schedule': ScheduleComponent,
    'e-view': ViewDirective,
    'e-views': ViewsDirective
  },
  data() {
    return {
      selectedDate: new Date(2024, 1, 15),
      cssClass: 'schedule-event-template',
      eventSettings: {
        dataSource: [
          {
            Id: 1,
            Subject: 'Environment Day',
            Description: 'A day that creates awareness to promote the healthy planet and reduce the air pollution crisis on nature earth.',
            StartTime: new Date(2024, 1, 15, 9, 0),
            EndTime: new Date(2024, 1, 15, 14, 0),
            SubCount: [
              { background: 'darkblue', height: '50%' },
              { background: 'lightblue', height: '50%' },
            ]
          },
          {
            Id: 2,
            Subject: 'Health Day',
            Description: 'A day that raises awareness on different health issues. It marks the anniversary of the foundation of WHO.',
            StartTime: new Date(2024, 1, 16, 9, 0),
            EndTime: new Date(2024, 1, 16, 14, 0),
            SubCount: [
              { background: 'yellow', height: '33.3%' },
              { background: 'yellowgreen', height: '33.3%' },
              { background: 'green', height: '33.3%' },
            ]
          },
          {
            Id: 3,
            Subject: 'Cancer Day',
            Description: 'A day that raises awareness on cancer and its preventive measures. Early detection saves life.',
            StartTime: new Date(2024, 1, 17, 9, 0),
            EndTime: new Date(2024, 1, 17, 14, 0),
            SubCount: [
              { background: 'pink', height: '50%' },
              { background: 'red', height: '50%' },
            ]
          }
        ]
      }
    };
  },
  provide: {
    schedule: [Week, Resize, DragAndDrop]
  }
}

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-buttons/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-calendars/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-dropdowns/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-inputs/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-navigations/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-popups/styles/bootstrap5.css';
@import '../node_modules/@syncfusion/ej2-vue-schedule/styles/bootstrap5.css';
</style>

Multi-Color events in Angular Schedule component

1 Oct 20255 minutes to read

In Scheduler we can display the multiple colors within a single event. This can be achieved by using the template option available within the eventSettings property. Here, we’ve used SubCount as an additional field. The SubCount field contains the background color and height values. Based on these values, events will be divided into different colors.

import { Component, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { EventSettingsModel, DayService, WeekService, WorkWeekService, MonthService, AgendaService, ResizeService, DragAndDropService, ScheduleModule } from '@syncfusion/ej2-angular-schedule';
@Component({
  imports: [ScheduleModule, CommonModule ],
  standalone: true,
  selector: "app-root",
  styleUrls: ['./index.css'],
  providers: [DayService, WeekService, WorkWeekService, MonthService, AgendaService, ResizeService, DragAndDropService],
  encapsulation: ViewEncapsulation.None,
  template: `<ejs-schedule width='100%' height='650px' [selectedDate]="selectedDate" [eventSettings]="eventSettings" cssClass='schedule-event-template'>
        <e-views>
          <e-view option="Week">
            <ng-template #eventTemplate let-data>
              <div class='template-wrap'>
                <ng-template ngFor let-item [ngForOf]="data.SubCount">
                  <div [style.background]="item.background" [style.height]="item.height">
                    <div class="subject"></div>
                  </div>
                </ng-template>
              </div>
          </ng-template>
        </e-view>
      </e-views>
    </ejs-schedule>`
})
export class AppComponent {
  public data: Record<string, any>[] = [
    {
      Id: 1,
      Subject: 'Environment Day',
      Description: 'A day that creates awareness to promote the healthy planet and reduce the air pollution crisis on nature earth.',
      StartTime: new Date(2024, 1, 15, 9, 0),
      EndTime: new Date(2024, 1, 15, 14, 0),
      SubCount: [
        { background: 'darkblue', height: '50%' },
        { background: 'lightblue', height: '50%' },
      ],
    },
    {
      Id: 2,
      Subject: 'Health Day',
      Description: 'A day that raises awareness on different health issues. It marks the anniversary of the foundation of WHO.',
      StartTime: new Date(2024, 1, 16, 9, 0),
      EndTime: new Date(2024, 1, 16, 14, 0),
      SubCount: [
        { background: 'yellow', height: '33.3%' },
        { background: 'yellowgreen', height: '33.3%' },
        { background: 'green', height: '33.3%' },
      ],
    },
    {
      Id: 3,
      Subject: 'Cancer Day',
      Tags: 'Life threatening cancer effects, Palliative care',
      Description: 'A day that raises awareness on cancer and its preventive measures. Early detection saves life.',
      StartTime: new Date(2024, 1, 17, 9, 0),
      EndTime: new Date(2024, 1, 17, 14, 0),
      SubCount: [
        { background: 'pink', height: '50%' },
        { background: 'red', height: '50%' },
      ],
    },
  ];
  public selectedDate: Date = new Date(2024, 1, 15);
  public eventSettings: EventSettingsModel = { dataSource: this.data };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Display multiple colors in single event in React Schedule component

19 Sep 202412 minutes to read

In Scheduler we can display the multiple colors within a single event. This can be achieved by using the eventTemplate option available within the views model. Here, we’ve used SubCount as an additional field. The SubCount field contains the background color and height values. Based on these values, events will be divided into different colors.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ScheduleComponent, ViewsDirective, ViewDirective, Day, Week, TimelineViews, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

const App = () => {
  const data = [
    {
      Id: 1,
      Subject: 'Environment Day',
      Description: 'A day that creates awareness to promote the healthy planet and reduce the air pollution crisis on nature earth.',
      StartTime: new Date(2024, 1, 15, 9, 0),
      EndTime: new Date(2024, 1, 15, 14, 0),
      SubCount: [
        { background: 'darkblue', height: '50%' },
        { background: 'lightblue', height: '50%' },
      ],
    },
    {
      Id: 2,
      Subject: 'Health Day',
      Description: 'A day that raises awareness on different health issues. It marks the anniversary of the foundation of WHO.',
      StartTime: new Date(2024, 1, 16, 9, 0),
      EndTime: new Date(2024, 1, 16, 14, 0),
      SubCount: [
        { background: 'yellow', height: '33.3%' },
        { background: 'yellowgreen', height: '33.3%' },
        { background: 'green', height: '33.3%' },
      ],
    },
    {
      Id: 3,
      Subject: 'Cancer Day',
      Description: 'A day that raises awareness on cancer and its preventive measures. Early detection saves life.',
      StartTime: new Date(2024, 1, 17, 9, 0),
      EndTime: new Date(2024, 1, 17, 14, 0),
      SubCount: [
        { background: 'pink', height: '50%' },
        { background: 'red', height: '50%' },
      ],
    },
  ];

  const eventTemplate = (props) => {
    return (
      <div className="template-wrap">
        {props.SubCount.map((item, index) => (
          <div key={index} style=>
            <div className="subject">{props.Subject}</div>
          </div>
        ))}
      </div>
    );
  };

  return (
    <ScheduleComponent cssClass='event-template' width='100%' height='550px' selectedDate={new Date(2024, 1, 15)} eventSettings=>
      <ViewsDirective>
        <ViewDirective option={'Week'} eventTemplate={eventTemplate} />
      </ViewsDirective>
      <Inject services={[Day, Week, TimelineViews, Resize, DragAndDrop]} />
    </ScheduleComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('schedule'));
root.render(<App />);
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ScheduleComponent, ViewsDirective, ViewDirective, Day, Week, TimelineViews, Inject, Resize, DragAndDrop } from '@syncfusion/ej2-react-schedule';

const App = () => {
  const data: Object[] = [
    {
      Id: 1,
      Subject: 'Environment Day',
      Description: 'A day that creates awareness to promote the healthy planet and reduce the air pollution crisis on nature earth.',
      StartTime: new Date(2024, 1, 15, 9, 0),
      EndTime: new Date(2024, 1, 15, 14, 0),
      SubCount: [
        { background: 'darkblue', height: '50%' },
        { background: 'lightblue', height: '50%' },
      ],
    },
    {
      Id: 2,
      Subject: 'Health Day',
      Description: 'A day that raises awareness on different health issues. It marks the anniversary of the foundation of WHO.',
      StartTime: new Date(2024, 1, 16, 9, 0),
      EndTime: new Date(2024, 1, 16, 14, 0),
      SubCount: [
        { background: 'yellow', height: '33.3%' },
        { background: 'yellowgreen', height: '33.3%' },
        { background: 'green', height: '33.3%' },
      ],
    },
    {
      Id: 3,
      Subject: 'Cancer Day',
      Description: 'A day that raises awareness on cancer and its preventive measures. Early detection saves life.',
      StartTime: new Date(2024, 1, 17, 9, 0),
      EndTime: new Date(2024, 1, 17, 14, 0),
      SubCount: [
        { background: 'pink', height: '50%' },
        { background: 'red', height: '50%' },
      ],
    },
  ];

  const eventTemplate = (props: any) => {
    return (
      <div className="template-wrap">
        {props.SubCount.map((item, index) => (
          <div key={index} style=>
            <div className="subject">{props.Subject}</div>
          </div>
        ))}
      </div>
    );
  };

  return (
    <ScheduleComponent cssClass='event-template' width='100%' height='550px' selectedDate={new Date(2024, 1, 15)} eventSettings=>
      <ViewsDirective>
        <ViewDirective option={'Week'} eventTemplate={eventTemplate} />
      </ViewsDirective>
      <Inject services={[Day, Week, TimelineViews, Resize, DragAndDrop]} />
    </ScheduleComponent>
  );

}
const root = ReactDOM.createRoot(document.getElementById('schedule'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Schedule</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-base/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-buttons/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-calendars/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-dropdowns/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-inputs/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-navigations/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-popups/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.1.17/ej2-react-schedule/styles/bootstrap5.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <link href="index.css" rel="stylesheet" />
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='schedule'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>